/* Autor: Sergio Blanco Cuaresma
 * Data: Agost 2002
 * Descripci: TAD impressora
 */

public class Impressora {
  private Cua treballs;
  private int memoria;
  private int copies;   // Copies que manquen per fer del treball actual

  Impressora(int mem) {
    treballs = new Cua();
    memoria=mem;
  }

  void afegir(Treball t) throws TooBig{
    if (t.mida() > memoria){
      throw new TooBig();
    }
    memoria = memoria - t.mida();   // Consumeix memria
    treballs.encuar(t);
  }

  // Mostra informaci per pantalla del contingut de la cua de treballs
  public void imprimir_info(){
    treballs.imprimir();
  }
 
  // Retorna null si encara queden copies per fer, o el treball si ja ha sigut
  // desencuat (s'han acabat de fer totes les copies)
  public Treball imprimir() throws CuaBuida{
    Treball t ;
  
    t = (Treball) treballs.cap();

    if (copies == 0){       // No hi han impressions pendents
      if (t.copies()==1) {  // Noms s'ha de fer 1 copia, podrem desencuar ja
        memoria = memoria + t.mida();
        treballs.desencuar();
        return t;
      } else {              // Com sn varies copies, encara no desencuem
        copies = t.copies();
        copies--;     // El proper cop que cridin imprimir, es realitzara una altra copia
      }
    } else {                // Hi han impressions pendents
      copies--;
      if (copies == 0){     // S'han acabat les pendents, treiem de la cua
        memoria = memoria + t.mida();
        treballs.desencuar();
        return t;
      }
    }
    return null;
  }

  public Treball primer_treball() throws CuaBuida{
    return (Treball)treballs.cap();
  }

}
