/* Autor: Sergio Blanco Cuaresma
 * Data: Agost 2002
 * Descripci: TAD Llista amb funcions especifiques tils pel programa
 */

public class Llista {
  private NodeLlista prim, ant;

  Llista() throws NoMemoria {
    NodeLlista aux;
    
    try {
      aux = new NodeLlista();    // Creaci del fantasma
    } catch (OutOfMemoryError e) {
      throw new NoMemoria();
    }

    aux.seguent(null);
    this.prim = aux;
    this.ant = aux;
  }


  // Nomes valid per llistes que contenen Treballs!!!
  // Mostra per pantalla el contingut de la llista de treballs
  void imprimir() throws PDIdreta {
    this.principi();
    System.out.println("--  Llistat Treballs  --");
    while (!this.finalLlista()) {
      ((Treball)(this.actual())).imprimir();
      
      this.avanzar();
    }
    System.out.println("-- Fi Llistat Treballs --");
  }

  
  void insertar (Object o) throws NoMemoria {
    NodeLlista PDI;
    NodeLlista aux = new NodeLlista();

    if (aux == null) {
      throw new NoMemoria();
    } else {
      aux.info(o);
      PDI = this.ant.seguent();
      this.ant.seguent(aux);
      aux.seguent(PDI);
      this.ant = aux;
    }
  }

  void esborrar() throws PDIdreta {
    NodeLlista PDI;

    PDI = this.ant.seguent();
    if (PDI == null) {
      throw new PDIdreta ();
    } else {
      this.ant.seguent (PDI.seguent());
    }
  }

  Object actual() throws PDIdreta {
    NodeLlista PDI;

    PDI = this.ant.seguent();
    if (PDI == null) {
      throw new PDIdreta();
    } else{
      return PDI.info();
    }
  }

  boolean buida() {
    return (this.prim.seguent() == null);
  }

  void principi() {
    this.ant = this.prim;
  }

  void avanzar() throws PDIdreta {
    NodeLlista PDI;
    PDI = this.ant.seguent();
    
    if (PDI == null) {
      throw new PDIdreta();
    } else {
      this.ant = PDI;
    }
  }

  boolean finalLlista() {
    return (this.ant.seguent() == null);
  }

}
      

