/* Autor: Sergio Blanco Cuaresma
 * Data: Agost 2002
 * Descripci: TAD Usuari
 */

public class Usuari {
  private String id;
  private int num_treballs;  // Nombre de treballs enviats, til per optimitzar consultes
  private Llista treballs;   // Llista de treballs que ha enviat, til per optimitzar consultes

  public Usuari (String user) throws NoMemoria {
    id = user;
    num_treballs=0;
    treballs = new Llista();
  }

  public String id (){
    return id;
  }

  public Llista llistat() {
    return treballs;
  }

  
  public int treballs(){
    return num_treballs;
  }

  // Afegeix a la llista de treball propia el treball que ha enviat
  // a la cua d'impressi
  public void treball_enviat(Treball t) throws PDIdreta, NoMemoria{
    while (!treballs.finalLlista()){
      treballs.avanzar();
    }
    treballs.insertar(t);
    num_treballs++;
  }

  // S'ha imprimit un treball que havia enviat, per tant treiem de la llista
  public void treball_finalitzat (Treball t) throws PDIdreta, NoTreballUser {
    treballs.principi();
    while ((!treballs.finalLlista()) && (treballs.actual() != t)){
      treballs.avanzar();
    }
    if (treballs.actual() == t){
      treballs.esborrar(); 
    } else {
      throw new NoTreballUser();
    }
    num_treballs--;
  }

}
